@echo off
CLS
setlocal EnableDelayedExpansion


REM ----------------------------------------------
REM These are defaults. Allows the batch file to be run directly without command-line parameters.
REM ----------------------------------------------

set DefaultSource=BLANK.HFE
set DefaultCount=100

REM ----------------------------------------------
set Filename=DSKA
set Padding=0000
set Extension=HFE

echo  FILE DUPLICATOR v1.0 by Prax (HxC Floppy Emulator Forums) http://torlus.com/floppy/forum/

IF "%1"=="" (
     SET count=%DefaultCount%
) ELSE (
     SET count=%1
)

IF "%2"=="" (
     SET Source=%DefaultSource%
) ELSE (
     SET Source=%2
)

REM The count before subtracting 1
set "absoluteCount=%count%"

set /a count-=1

set "leadingZeros=%Padding%%count%"

echo -------------------------------------------------------------------------------------------
echo  SOURCE FILENAME..: %Source%
echo  NUMBER TO COPY...: %absoluteCount%
echo  FILE FORMAT......: %Filename%%Padding%.%Extension% ~ %Filename%!leadingZeros:~-4!.%Extension% 
echo -------------------------------------------------------------------------------------------
echo  SYNTAX: DUPLICATOR[.BAT] [1~9999 (Default: %DefaultCount%)] [SOURCE_FILENAME (Default: %DefaultSource%)]
echo  NOTE: Existing files will be skipped.
echo -------------------------------------------------------------------------------------------

SET /P AREYOUSURE=Are you sure (Y/[N])?
IF /I "%AREYOUSURE%" NEQ "Y" GOTO END

:START

for /L %%i in (0, 1, %count%) do (
     set "leadingZeros=%Padding%%%i"

     if exist %Filename%!leadingZeros:~-4!.%Extension% (
          echo [SKIP] %Filename%!leadingZeros:~-4!.%Extension% Exists.
     ) else (
          copy %Source% %Filename%!leadingZeros:~-4!.%Extension% >NUL
          echo [COPY] %Filename%!leadingZeros:~-4!.%Extension% Created.
     )
)
echo ------------------------------------------------------------
echo  DONE!
echo ------------------------------------------------------------
pause
exit

:END
echo ------------------------------------------------------------
echo  ABORTED
echo ------------------------------------------------------------
pause
exit